import { Component, HTMLAttributes, ReactElement } from "react";
type Size = {
    height?: number;
    width?: number;
};
type Props = {
    children: (size: Size) => ReactElement;
    defaultHeight?: number;
    defaultWidth?: number;
    disableHeight?: boolean;
    disableWidth?: boolean;
    nonce?: string;
    onResize?: (size: Size) => void;
    tagName?: string;
} & Omit<HTMLAttributes<HTMLDivElement>, "children">;
type State = {
    height: number;
    width: number;
};
type ResizeHandler = (element: HTMLElement, onResize: () => void) => void;
type DetectElementResize = {
    addResizeListener: ResizeHandler;
    removeResizeListener: ResizeHandler;
};
declare class AutoSizer extends Component<Props, State> {
    static defaultProps: {
        onResize: () => void;
        disableHeight: boolean;
        disableWidth: boolean;
        style: {};
    };
    state: {
        height: number;
        width: number;
    };
    _parentNode: HTMLElement | null;
    _autoSizer: HTMLElement | null;
    _detectElementResize: DetectElementResize | null;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): ReactElement;
    _onResize: () => void;
    _setRef: (autoSizer: HTMLElement | null) => void;
}
export default AutoSizer;

//# sourceMappingURL=react-virtualized-auto-sizer.d.ts.map
